//generic function to query our utils.get_feed.php function and display the results
// used in blog, my_blog, news, posterous, tumblr, facebook pages
(function() {

	// To use fontAwesome (required the IconicFont.js)
	var IconicFont = require('/lib/IconicFont'),
	    iconicFont = new IconicFont({
		font : '/lib/FontAwesome'
	});

	var feedtable = {};
	feedtable.makeFeedTable = function(feeds, defaultImage, imageOn, descOn, dateOn, useDetailPage, useSystemBrowser) {

		if (imageOn == null)
			var imageOn = true;

		if (descOn == null)
			var descOn = true;
		var descriptionHeight = descSize * 5;
		if (dateOn == null)
			var dateOn = true;
		// rows link to a detail page, instead of the 'link'from the rss feed
		if (useDetailPage == null)
			var useDetailPage = true;
		// should links open in the system browser, or a modal window (only used if useDetailPage is false)
		if (useSystemBrowser == null)
			var useSystemBrowser = false;

		// ---------------------------
		// shouldn't need to edit much below this
		// ---------------------------
		if (imageOn == false) {
			imageSize = 1;
		}

		var rows = [];
		//to hold all table data rows

		setTimeout(function() {
			getFeeds();
		}, 60);

		var container = Titanium.UI.createView({
			backgroundColor : "transparent",
			top : homeButtonSize + rowMargin,
			bottom : adWindowHeight + padding,
			left : 0,
			right : 0
		});

		function isArray(obj) {
			try {
				if (obj.constructor.toString().indexOf("Array") == -1) {
					return (false);
				} else {
					return (true);
				}
			} catch(e) {
				return (false);
			}
		}

		var bol = true;
		// --- opens a window with all the rss data displayed on it
		function openDetailWindow(data) {

			Ti.API.info("opening detail page");
			var w = Titanium.UI.createWindow({
				//title : L("Details"),
				backgroundColor : "transparent",
				navBarHidden : false,
				theme : "Theme.AppCompat.Fullscreen",
				fullscreen : true,
				// backgroundImage : Ti.UI.currentWindow.bgImage,
			});

			var bgImg = myApp.global.createBackgroundImage();
			w.add(bgImg);
			// if (is_android == false) {
			// var navWin = Titanium.UI.iOS.createNavigationWindow({
			// modal : true,
			// window : w,
			// });
			// }

			var container = Ti.UI.createView({
				layout : "vertical",
				height : Ti.UI.SIZE,
				backgroundColor : "transparent",
				top : homeButtonSize + rowMargin,
			});
			w.add(container);

			var myTitle = data.myTitle.substring(0, 85) + '...';
			Ti.API.info("myTitle : " + myTitle);
			var titletxt = Ti.UI.createLabel({
				left : rowMargin,
				right : rowMargin,
				height : Titanium.UI.SIZE,
				top : 25,
				textAlign : 'left',
				text : myTitle,
				font : {
					fontWeight : 'bold',
					fontSize : titleSize + 2
				},
				//color : "#000"
				color : col_title,
			});
			titletxt.addEventListener('click', function() {
				Ti.API.info("title clicked");
				Titanium.Platform.openURL(data.myLink);
			});
			container.add(titletxt);

			var dateView = Ti.UI.createView({
				top : rowMargin / 2,
				height : Ti.UI.SIZE,
				width : deviceWidth,
				layout : 'horizontal'
			});
			container.add(dateView);

			// clock image
			// var clockImage = Ti.UI.createImageView({
			// height : buttonHeight / 2.2,
			// width : buttonHeight / 2.2,
			// left : rowMargin,
			// image : '/images/clock_icon.png',
			// opacity : 0.7,
			// top : 3,
			// });
			// dateView.add(clockImage);

			var datetxt = Ti.UI.createLabel({
				left : rowMargin,
				right : rowMargin,
				height : Titanium.UI.SIZE,
				top : 5,
				textAlign : 'left',
				text : data.myDate,
				font : {
					fontWeight : 'normal',
					fontSize : dateSize + 2
				},
				opacity : 0.7,
				//color : "#000"
				color : col_text,
			});
			dateView.add(datetxt);

			var detailHtml = data.myDescription;
			if (data.myEncoded != null) {
				detailHtml = data.myEncoded;
			}
			var webview = Ti.UI.createWebView({
				//html : myApp.global.makehtml(detailHtml, "#000"),
				html : myApp.global.makehtml(detailHtml, col_text),
				top : 5,
				height : deviceHeight * 0.6,
				cacheMode : (is_android) ? Titanium.UI.Android.WEBVIEW_LOAD_NO_CACHE : 0,
				backgroundColor : 'transparant',
			});
			container.add(webview);
			var BtnH = deviceHeight * (0.062);
			Ti.API.info("deviceHeight :" + deviceHeight + " BtnH : " + BtnH);
			var moretxt = Ti.UI.createButton({
				// right : rowMargin,
				top : rowMargin,
				width : BtnH * 6,
				height : BtnH,
				bottom : 10,
				textAlign : 'center',
				title : L("Click_for_More"),
				font : {
					fontWeight : 'bold',
					fontSize : titleSize
				},
				//color : "#ffff",
				color : col_title,
				borderRadius : BtnH / 6,
				focusable : true,
				//backgroundColor : '#04B431',
			});
			moretxt.addEventListener('click', function() {
				Ti.API.info("more clicked");
				moretxt.color = '#FFA500';
				setTimeout(function() {
					Titanium.Platform.openURL(data.myLink);
					moretxt.color = col_title;
				}, 500);
			});
			container.add(moretxt);

			var closeBtn = Titanium.UI.createButton({
				//title : L('Back'),
				left : 0,
				width : homeButtonSize,
				height : homeButtonSize,
				//top : rowMargin,
				top : 0,
				color : col_title,
				font : {
					fontSize : titleSize,
					fontFamily : iconicFont.fontfamily
				},
				title : iconicFont.icon('fa-arrow-left'),
				textAlign : Ti.UI.TEXT_ALIGNMENT_CENTER,
				verticalAlign : Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
				backgroundColor : 'transparant',
			});
			closeBtn.addEventListener('click', function() {
				w.close();
				// if (is_android == false) {
				// navWin.close();
				// }
			});

			myApp.global.addPageTitle(L("Details"), 99, w);
			w.add(closeBtn);

			// if (is_android == false) {
			// navWin.open();
			// }
			w.open({
				modal : true
			});

			//	Ti.UI.currentWindow.orientationModes = [Titanium.UI.PORTRAIT];
			w.orientationModes = [Titanium.UI.PORTRAIT];
			//	Titanium.UI.currentTab.open(w,{animated:true});

		}

		// create table view
		var tableview = Titanium.UI.createTableView({
			//className: "mytable",
			//		opacity : tableOpacity,
			backgroundColor : 'transparent',
			top : 0,
			bottom : 0,
			left : 0,
			right : 0,
			separatorColor : 'transparent',
			// borderRadius : tableRadius
			//		borderColor:col_text
		});
		var isClicked = true;
		// create table view event listener
		tableview.addEventListener('click', function(e) {

			var row = e.row;
			var rowdata = e.rowData;
			if (!e.source.type && e.source.type != 'social') {//if you've not clicked on the social buttons, it must be the row...
				Ti.API.info("row clicked");
				if (isClicked) {
					isClicked = false;
					// event data
					var index = e.index;
					var section = e.section;

					Ti.API.info("row clicked: " + e.index);
					if (is_android) {
						row.backgroundColor = '#0080FF';
					};
					tableview.touchEnabled = false;
					if (useDetailPage == true) {
						// open the detail page
						openDetailWindow(rowdata);
						setTimeout(function() {
							isClicked = true;
						}, 500);
					} else {
						if (useSystemBrowser == true) {
							// open link using system browser
							Titanium.Platform.openURL(rowdata.myLink);
							setTimeout(function() {
								isClicked = true;
							}, 500);
						} else {
							// open a web browser page with the link
							myApp.global.getWebView(rowdata.myLink, true, "close");
							setTimeout(function() {
								isClicked = true;
							}, 500);
						}
					}
					tableview.touchEnabled = true;
					setTimeout(function() {
						if (is_android) {
							row.backgroundColor = 'transparent';
						}
					}, 250);
				}
			}

		});
		// add table view to the window
		container.add(tableview);

		// -----------------------
		// these are the rss retrieving and formatting functions
		// ----------------
		var cnt = 0;

		function loadData(url) {
			cnt++;
			var xhr = Titanium.Network.createHTTPClient();
			var datastring = '';
			var datajson = null;
			xhr.onload = function() {
				try {
					datastring = this.responseText;
					// datajson = JSON.parse(datastring);
					datajson = eval('(' + datastring + ')');
					populateTable(datajson);
				} catch(err) {
					alert(L("sorry_problem_loading_configuration_data"));
				}
			};
			xhr.onerror = function(e) {
				alert(L("sorry_problem_loading_configuration_data"));
			};
			xhr.setTimeout(25000);
			xhr.open("GET", url);
			xhr.send();
		}

		function getFeeds() {
			if (myApp.global.checkNetwork(false)) {
				rows = [];
				//clear data before getting new data
				for (var i = 0; i < feeds.length; i++) {
					var url = "https://utils.infinitemonkeys.mobi/get_feed.php?feed=" + escape(feeds[i]);
					Ti.API.info('url for getting feeds is', url);
					loadData(url);
				}
			}

		}

		function sortDate(a, b) {//sort a given array of twitter json statuses by date
			try {
				var y = dateFormat(a.myDate, "isoDateTime");
				var x = dateFormat(b.myDate, "isoDateTime");
				// Ti.API.info("y : "+ y + " x : "+ x);
				if (y > x)
					return -1;
				if (y < x)
					return 1;
				else
					return 0;
			} catch(sortErr) {
				return 1;
			}
		}

		function populateTable(data) {// cycle through data and load it into the tableview
			actInd.show();
			Ti.API.info("populating table with: " + data.length + " rows");
			try {
				for (var c = 0; c < data.length; c++) {

					//----------- assign the variable from the data stream----------------------------------
					var dataTitle = null;

					if ("title" in data[c]) {
						dataTitle = data[c].title;
					} else {
						dataTitle = "(untitled)";
					}
					dataTitle = fullClean(dataTitle);

					var dateString = null;
					if ("pubDate" in data[c]) {
						Ti.API.info("if dateString : " + data[c].pubDate);
						try {
							//dateString = dateFormat(data[c].pubDate);
							dateString = new Date(data[c].pubDate);
							dateString = dateString.format("ddd, mmm d yy, h:MM TT");
							Ti.API.info("try dateString : " + dateString);
						}//data[c].pubDate;
						catch(dateErr) {
							dateString = data[c].pubDate;
							Ti.API.info("catch dateString : " + dateString);
						}
					} else {
						dateString = dateFormat();
						Ti.API.info("else dateString : " + dateString);
					}

					var dataDescription = null;
					// sometimes short, sometimes full html, sometimes an array with both !!
					if ("description" in data[c]) {
						dataDescription = convert_codes(data[c].description);
					} else {
						dataDescription = "";
					}

					var dataLink = null;
					if ('link' in data[c]) {
						dataLink = data[c].link;
					} else {
						dataLink = 'http://#';
					}

					var dataImageUrl = defaultImage;
					if (imageOn) {
						if ('thumbnail' in data[c]) {
							if (data[c]['thumbnail'] != null && data[c]['thumbnail'] != "") {//if it's not empty
								dataImageUrl = data[c]['thumbnail'];
								Ti.API.info("found media:thumbnail - " + dataImageUrl);
							}
						}
					}
					//----------format the table--------------------------------------------------------
					// create the row and add the component parts
					var row = Ti.UI.createTableViewRow({
						// className : "myrow",
						backgroundColor : "transparent",
						height : Titanium.UI.SIZE,
						hasDetail : false,
						myTitle : dataTitle,
						myDescription : dataDescription,
						myDate : dateString,
						myImage : dataImageUrl,
						myLink : dataLink,
						selectedBackgroundColor : "transparent"
					});

					var cardView = Ti.UI.createView({
						top : padding / 2,
						bottom : padding / 2,
						left : padding,
						right : padding,
						height : Titanium.UI.SIZE,
						layout : 'vertical',
						//					opacity : opacity,
						backgroundColor : col_back,
						borderRadius : padding * 0.66,
						//borderWidth : padding / 4,
						//borderColor : col_text
					});
					row.add(cardView);

					var cardHeadContainer = Ti.UI.createView({
						top : 2,
						left : rowMargin,
						right : rowMargin,
						height : Titanium.UI.SIZE,
					});

					var titleContainer = Ti.UI.createView({
						//top : 0,
						//left : rowMargin,
						right : rowMargin,
						left : rowMargin + imageSize,
						height : Titanium.UI.SIZE,
						layout : 'vertical',
					});

					var imageContainer = Ti.UI.createView({
						top : 0,
						left : 0,
						//left : rowMargin,
						//right : rowMargin,
						height : Titanium.UI.SIZE,
						width : Titanium.UI.SIZE,
					});

					var descriptionContainer = Ti.UI.createView({
						top : rowMargin,
						//bottom : rowMargin,
						//left : rowMargin,
						//right : rowMargin,
						height : Titanium.UI.SIZE,
						layout : 'vertical',
					});
					cardView.add(cardHeadContainer);
					cardHeadContainer.add(imageContainer);
					cardHeadContainer.add(titleContainer);
					cardView.add(descriptionContainer);

					// image
					if (imageOn) {
						var image = Ti.UI.createImageView({
							height : imageSize,
							width : imageSize,
							left : 0,
							//top : padding,
							image : dataImageUrl,
							borderRadius : imageSize / 2,
							//borderColor : "#777777",
							//borderWidth : 2,
							//backgroundColor : "#666666"
						});
						imageContainer.add(image);
					}

					// title
					Ti.API.info("dataTitle : " + dataTitle);
					var titleTxt = Ti.UI.createLabel({
						//top : 2,
						//left : rowMargin +imageSize,
						height : titleSize + border,
						textAlign : 'left',
						text : dataTitle,
						font : {
							fontWeight : 'bold',
							fontSize : titleSize + 2
							//fontSize : titleSize
						},
						color : col_title,
						ellipsize : true,
						wordWrap : false,
						left : 0,
					});
					titleContainer.add(titleTxt);

					// description
					// Image
					//var  rex = /<img[^>]+src="?([^"\s]+)"?\s*\/>/g;
					
					//var rex = /src=\".+\.jpg\"|src=\".+\.gif\"|src=\".+\.png\"/;
					/****** New rex extraction implementation 21 Dec 2015 *******/
					var rex = /<img[^>]+src="?([^"\s]+)"?\s*\/>/g;
					var urls = [];
					while ( m = rex.exec(dataDescription)) {
						urls.push(m[1]);
					}
					Ti.API.info("urls : + "+ urls);
					
					var image_obj = urls[0];
					Ti.API.info("image_ojb Type : " + image_obj);

					//image_obj = image_obj.toString().replace('"','');
					//Ti.API.info("Image Object out " + image_obj + " : " + dataDescription);
					if (image_obj != null) {
						// image_obj = image_obj.toString().replace('src=', '');
						// image_obj = image_obj.toString().replace('"', '');
						// image_obj = image_obj.toString().replace('"', '');
						Ti.API.info("Image Object " + image_obj);

						var descImg = Ti.UI.createImageView({
							image : image_obj,
							//width : Ti.UI.FILL,
							left : padding,
							right : padding,
						});
						descriptionContainer.add(descImg);
					}

					// Text
					// var description = Ti.UI.createLabel();
					var descData;
					if (fullClean(dataDescription).length > 450) {
						descData = fullClean(dataDescription).substring(0, 450) + '...';
					} else {
						descData = fullClean(dataDescription);
					}

					if (descOn == true) {
						description = Ti.UI.createLabel({
							top : padding / 2,
							//left : rowMargin +imageSize,
							left : rowMargin,
							right : rowMargin,
							height : Titanium.UI.SIZE,
							textAlign : 'left',
							text : descData,
							font : {
								fontWeight : 'normal',
								fontSize : descSize + 2
							},
							color : col_text
						});
						descriptionContainer.add(description);
					}

					// clock image
					/*
					var clockImage = Ti.UI.createImageView({
					height : buttonHeight / 2.2,
					width : buttonHeight / 2.2,
					left : 0,
					image : '/images/clock_icon.png',
					opacity : 0.7,
					});
					dateContainer.add(clockImage);*/

					// date
					var date = Ti.UI.createLabel();
					if (dateOn == true) {
						date = Ti.UI.createLabel({
							top : 3 * scaleFactor,
							//left : buttonHeight / 1.5,
							left : 0,
							height : Titanium.UI.SIZE,
							textAlign : 'left',
							text : dateString,
							font : {
								fontWeight : 'normal',
								fontSize : dateSize + 2
								//fontSize : dateSize
							},
							opacity : 0.7,
							color : col_text,
							ellipsize : true,
							wordWrap : false
						});

						titleContainer.add(date);
					}
					//add social buttons with link and event listeners
					// var social = getSocialButton(dataLink, dataTitle, "", dataLink);
					// social.right = padding;
					// // position the view
					// social.bottom = padding;
					// descriptionContainer.add(social);

					/*
					descImg.addEventListener('load',function(e){
					Ti.API.info("descImg Load Event");
					//descImg.width = Ti.UI.FILL;
					descriptionContainer.height = Ti.UI.SIZE;
					});*/

					//-------- end social buttons----------

					// row.add(rowContainer);
					rows.push(row);
				}
				Ti.API.info("sorting rows: " + rows.length);
				rows.sort(sortDate);
				//sort rows by row.myDate
				if (cnt == feeds.length) {
					tableview.setData(rows);
				}

				tableview.separatorColor = 'transparent';
				//actually put the data into the table
			} catch (err) {
				Ti.API.info("there was a problem with some of the data populating the table: " + err);
			}
			if (cnt == feeds.length) {
				actInd.hide();
			}
		}


		myCurrentWindow.add(container);
		myCurrentWindow.add(actInd);
	};
	myApp.feedtable = feedtable;
})();
