/*
 * version 1.0 - created for launch
 */
	 removeNL=function(s) {
		var n = s.replace(/\n /g, '');
		// n+="that\'s all folks"
		return n;
	};

	removeBreaks=function (s) {
		s = s.replace(/(\r\n|\n|\r)/gm, " ");
		return s;
	};

	stripslashes=function (str) {
		return str.replace(/\\/gm, '');
	};

	trim=function (str) {
		return str.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
	};

	 caps=function(string) {
		return string.charAt(0).toUpperCase() + string.slice(1);
	};

	function htmlspecialchars_decode(string, quote_style) {
		// *     example 1: htmlspecialchars_decode("<p>this -&gt; &quot;</p>", 'ENT_NOQUOTES');
		// *     returns 1: '<p>this -> &quot;</p>'
		// *     example 2: htmlspecialchars_decode("&amp;quot;");
		// *     returns 2: '&quot;'
		var optTemp = 0,
		    i = 0,
		    noquotes = false;
		if ( typeof quote_style === 'undefined') {
			quote_style = 2;
		}
		string = string.toString().replace(/&lt;/g, '<').replace(/&gt;/g, '>');
		var OPTS = {
			'ENT_NOQUOTES' : 0,
			'ENT_HTML_QUOTE_SINGLE' : 1,
			'ENT_HTML_QUOTE_DOUBLE' : 2,
			'ENT_COMPAT' : 2,
			'ENT_QUOTES' : 3,
			'ENT_IGNORE' : 4
		};
		if (quote_style === 0) {
			noquotes = true;
		}
		if ( typeof quote_style !== 'number') {// Allow for a single string or an array of string flags
			quote_style = [].concat(quote_style);
			for ( i = 0; i < quote_style.length; i++) {
				// Resolve string input to bitwise e.g. 'PATHINFO_EXTENSION' becomes 4
				if (OPTS[quote_style[i]] === 0) {
					noquotes = true;
				} else if (OPTS[quote_style[i]]) {
					optTemp = optTemp | OPTS[quote_style[i]];
				}
			}
			quote_style = optTemp;
		}
		if (quote_style & OPTS.ENT_HTML_QUOTE_SINGLE) {
			string = string.replace(/&#0*39;/g, "'");
			// PHP doesn't currently escape if more than one 0, but it should
			// string = string.replace(/&apos;|&#x0*27;/g, "'"); // This would also be useful here, but not a part of PHP
		}
		if (!noquotes) {
			string = string.replace(/&quot;/g, '"');
		}
		// Put this in last place to avoid escape being double-decoded
		string = string.replace(/&amp;/g, '&');

		return string;
	}

	convert_codes=function (str) {
		str = str.replace(/&amp;/g, "&");
		str = str.replace(/&gt;/g, ">");
		str = str.replace(/&lt;/g, "<");
		str = str.replace(/&quot;/g, "\"");
		str = str.replace(/&#039;/g, "'");
		return str;
	};

	function strip_tags(str, allowed_tags) {

		// * example 1: strip_tags('<p>Kevin</p> <br /><b>van</b> <i>Zonneveld</i>',
		// '<i><b>');
		// * returns 1: 'Kevin <b>van</b> <i>Zonneveld</i>'
		// * example 2: strip_tags('<p>Kevin <img src="someimage.png"
		// onmouseover="someFunction()">van <i>Zonneveld</i></p>', '<p>');
		// * returns 2: '<p>Kevin van Zonneveld</p>'
		// * example 3: strip_tags("<a href='http://kevin.vanzonneveld.net'>Kevin
		// van Zonneveld</a>", "<a>");
		// * returns 3: '<a href='http://kevin.vanzonneveld.net'>Kevin van
		// Zonneveld</a>'
		// * example 4: strip_tags('1 < 5 5 > 1');
		// * returns 4: '1 < 5 5 > 1'

		var key = '',
		    allowed = false;
		var matches = [];
		var allowed_array = [];
		var allowed_tag = '';
		var i = 0;
		var k = '';
		var html = '';

		var replacer = function(search, replace, str) {
			return str.split(search).join(replace);
		};
		// Build allowed tags associative array
		if (allowed_tags) {
			allowed_array = allowed_tags.match(/([a-zA-Z0-9]+)/gi);
		}
		str += '';

		// Match tags
		matches = str.match(/(<\/?[\S][^>]*>)/gi);

		// Go through all HTML tags
		for (key in matches) {

			if (key) {

				// Save HTML tag
				html = matches[key].toString();

				// Is tag not in allowed list? Remove from str!
				allowed = false;

				// Go through all allowed tags
				for (k in allowed_array) {

					if (k) {

						// Init
						allowed_tag = allowed_array[k];
						i = -1;

						if (i !== 0) {
							i = html.toLowerCase().indexOf('<' + allowed_tag + '>');
						}
						if (i !== 0) {
							i = html.toLowerCase().indexOf('<' + allowed_tag + ' ');
						}
						if (i !== 0) {
							i = html.toLowerCase().indexOf('</' + allowed_tag);
						}

						// Determine
						if (i === 0) {
							allowed = true;
							break;
						}

					}
				}

				if (!allowed) {
					str = replacer(html, "", str);
					// Custom replace. No regexing
				}

			}
		}

		return str;
	}

	function fullClean(text) {
		text = convert_codes(text);
		text = htmlspecialchars_decode(text);
		text = strip_tags(text, "ENT_QUOTES")
		return text;
	}

	/*
	 * Date Format 1.2.3
	 * (c) 2007-2009 Steven Levithan <stevenlevithan.com>
	 * MIT license
	 *
	 * Includes enhancements by Scott Trenda <scott.trenda.net>
	 * and Kris Kowal <cixar.com/~kris.kowal/>
	 *
	 * Accepts a date, a mask, or a date and a mask.
	 * Returns a formatted version of the given date.
	 * The date defaults to the current date/time.
	 * The mask defaults to dateFormat.masks.default.
	 */

	var dateFormat = function() {
		var token = /d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,
		    timezone = /\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,
		    timezoneClip = /[^-+\dA-Z]/g,
		    pad = function(val, len) {
			val = String(val);
			len = len || 2;
			while (val.length < len)
			val = "0" + val;
			return val;
		};
		// Regexes and supporting functions are cached through closure
		return function(date, mask, utc) {
			var dF = dateFormat;

			// You can't provide utc if you skip other args (use the "UTC:" mask prefix)
			if (arguments.length == 1 && Object.prototype.toString.call(date) == "[object String]" && !/\d/.test(date)) {
				mask = date;
				date = undefined;
			}

			// Passing date through Date applies Date.parse, if necessary
			date = date ? new Date(date) : new Date;
			if (isNaN(date))
				throw SyntaxError("invalid date");
			mask = String(dF.masks[mask] || mask || dF.masks["default"]);

			// Allow setting the utc argument via the mask
			if (mask.slice(0, 4) == "UTC:") {
				mask = mask.slice(4);
				utc = true;
			}

			var _ = utc ? "getUTC" : "get",
			    d = date[_ + "Date"](),
			    D = date[_ + "Day"](),
			    m = date[_ + "Month"](),
			    y = date[_ + "FullYear"](),
			    H = date[_ + "Hours"](),
			    M = date[_ + "Minutes"](),
			    s = date[_ + "Seconds"](),
			    L = date[_ + "Milliseconds"](),
			    o = utc ? 0 : date.getTimezoneOffset(),
			    flags = {
				d : d,
				dd : pad(d),
				ddd : dF.i18n.dayNames[D],
				dddd : dF.i18n.dayNames[D + 7],
				m : m + 1,
				mm : pad(m + 1),
				mmm : dF.i18n.monthNames[m],
				mmmm : dF.i18n.monthNames[m + 12],
				yy : String(y).slice(2),
				yyyy : y,
				h : H % 12 || 12,
				hh : pad(H % 12 || 12),
				H : H,
				HH : pad(H),
				M : M,
				MM : pad(M),
				s : s,
				ss : pad(s),
				l : pad(L, 3),
				L : pad(L > 99 ? Math.round(L / 10) : L),
				t : H < 12 ? "a" : "p",
				tt : H < 12 ? "am" : "pm",
				T : H < 12 ? "A" : "P",
				TT : H < 12 ? "AM" : "PM",
				Z : utc ? "UTC" : (String(date).match(timezone) || [""]).pop().replace(timezoneClip, ""),
				o : (o > 0 ? "-" : "+") + pad(Math.floor(Math.abs(o) / 60) * 100 + Math.abs(o) % 60, 4),
				S : ["th", "st", "nd", "rd"][d % 10 > 3 ? 0 : (d % 100 - d % 10 != 10) * d % 10]
			};

			return mask.replace(token, function($0) {
				return $0 in flags ? flags[$0] : $0.slice(1, $0.length - 1);
			});
		};
	}();

	// Some common format strings
	dateFormat.masks = {
		"default" : "ddd mmm dd yyyy HH:MM:ss",
		shortDate : "m/d/yy",
		mediumDate : "mmm d, yyyy",
		longDate : "mmmm d, yyyy",
		fullDate : "dddd, mmmm d, yyyy",
		shortTime : "h:MM TT",
		mediumTime : "h:MM:ss TT",
		longTime : "h:MM:ss TT Z",
		isoDate : "yyyy-mm-dd",
		isoTime : "HH:MM:ss",
		isoDateTime : "yyyy-mm-dd'T'HH:MM:ss",
		isoUtcDateTime : "UTC:yyyy-mm-dd'T'HH:MM:ss'Z'",
		friendly : "ddd, mmm dd, h:MM TT"
	};

	// Internationalization strings
	dateFormat.i18n = {
		dayNames : ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
		monthNames : ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec", "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"]
	};

	// For convenience...
	Date.prototype.format = function(mask, utc) {
		return dateFormat(this, mask, utc);
	};
	// Date ago function

	function DateAgo(date_str) {
		var time_formats = [[60, 'just now', 1], // 60
		[120, '1 minute ago', '1 minute from now'], // 60*2
		[3600, 'minutes', 60], // 60*60, 60
		[7200, '1 hour ago', '1 hour from now'], // 60*60*2
		[86400, 'hours', 3600], // 60*60*24, 60*60
		[172800, 'yesterday', 'tomorrow'], // 60*60*24*2
		[604800, 'days', 86400], // 60*60*24*7, 60*60*24
		[1209600, 'last week', 'next week'], // 60*60*24*7*4*2
		[2419200, 'weeks', 604800], // 60*60*24*7*4, 60*60*24*7
		[4838400, 'last month', 'next month'], // 60*60*24*7*4*2
		[29030400, 'months', 2419200], // 60*60*24*7*4*12, 60*60*24*7*4
		[58060800, 'last year', 'next year'], // 60*60*24*7*4*12*2
		[2903040000, 'years', 29030400], // 60*60*24*7*4*12*100, 60*60*24*7*4*12
		[5806080000, 'last century', 'next century'], // 60*60*24*7*4*12*100*2
		[58060800000, 'centuries', 2903040000] // 60*60*24*7*4*12*100*20, 60*60*24*7*4*12*100
		];
		var time = ('' + date_str).replace(/-/g, "/").replace(/[TZ]/g, " ").replace(/^\s\s*/, '').replace(/\s\s*$/, '');
		if (time.substr(time.length - 4, 1) == ".")
			time = time.substr(0, time.length - 4);
		var seconds = (new Date - new Date(time)) / 1000;
		var token = 'ago',
		    list_choice = 1;
		if (seconds < 0) {
			seconds = Math.abs(seconds);
			token = 'from now';
			list_choice = 2;
		}
		var i = 0,
		    format;
		while ( format = time_formats[i++])
		if (seconds < format[0]) {
			if ( typeof format[2] == 'string')
				return format[list_choice];
			else
				return Math.floor(seconds / format[2]) + ' ' + format[1] + ' ' + token;
		}

		return time;
	};

	function linkify(text) {
		// text = text.replace(/[ \t]{2,}/," ");
		return text.replace(/(https?:\/\/\S+)/gi, function(s) {
			return '<a href="' + s + '">' + s + '</a>';
		});
	}


function invertHex(hexnum){
  var has_hash = hexnum.indexOf("#");
  hexnum = hexnum.replace("#","");	//strip it off if it exists
  // alert(hexnum);
  if(hexnum.length != 6) {
    // alert("Hex color must be six hex numbers in length.");
    return hexnum;
  }
	
  hexnum = hexnum.toUpperCase();
  var splitnum = hexnum.split("");
  var resultnum = "";
  var simplenum = "FEDCBA9876".split("");
  var complexnum = new Array();
  complexnum.A = "5";
  complexnum.B = "4";
  complexnum.C = "3";
  complexnum.D = "2";
  complexnum.E = "1";
  complexnum.F = "0";
	
  for(i=0; i<6; i++){
    if(!isNaN(splitnum[i])) {
      resultnum += simplenum[splitnum[i]]; 
    } else if(complexnum[splitnum[i]]){
      resultnum += complexnum[splitnum[i]]; 
    } else {
      return hexnum;
    }
  }

	if(has_hash > -1)
		resultnum = "#" + resultnum;
  	return resultnum;
}