function getGeoLocation() {
	var myLoc = {	//default coordinates
		coords: {
			latitude:-90,
			longitude:0
		}
	};
	//Ti.API.info('GPS DEFAULT LOCATION: '+myLoc.coords.latitude);
	
	Ti.Geolocation.preferredProvider = "gps";
	Ti.Geolocation.purpose = "GPS";
	if (Titanium.Geolocation.locationServicesEnabled==false) {
		Ti.API.info('GPS disabled');
	} else {
		if (Titanium.Platform.name != 'android') {
			var authorization = Titanium.Geolocation.locationServicesAuthorization
			Ti.API.info('GPS Authorization: '+authorization);
			if (authorization == Titanium.Geolocation.AUTHORIZATION_DENIED) {
				Ti.API.info('GPS not allowed');
			} else if (authorization == Titanium.Geolocation.AUTHORIZATION_RESTRICTED) {
				Ti.API.info('GPS not allowed');
			}
		}

		Titanium.Geolocation.accuracy = Titanium.Geolocation.ACCURACY_BEST;
		Titanium.Geolocation.distanceFilter = 10;

		Titanium.Geolocation.getCurrentPosition( function(e) {
			if (!e.success || e.error) {
				//Ti.API.info("some GPS error: "+JSON.stringify(e.error));
				return;
			}
			var longitude = e.coords.longitude;
			var latitude = e.coords.latitude;
			var altitude = e.coords.altitude;
			var heading = e.coords.heading;
			var accuracy = e.coords.accuracy;
			var speed = e.coords.speed;
			var timestamp = e.coords.timestamp;
			var altitudeAccuracy = e.coords.altitudeAccuracy;
			//Ti.API.info('speed ' + speed);
			//Titanium.API.info('geo - current location: ' + new Date(timestamp) + ' long ' + longitude + ' lat ' + latitude + ' accuracy ' + accuracy);
			
			//set the return values of the parent function
			myLoc.coords.latitude = e.coords.latitude;
			myLoc.coords.longitude = e.coords.longitude;
			return;
		});
	}
	//Titanium.API.info("returning myLoc: " + myLoc.coords.latitude);
	Titanium.App.Properties.setObject("myLoc", myLoc);	//set global property for general use
	return myLoc;
}