function Settings (buttonPadding, buttonPaddingMeasure)
{
	this.buttonPadding = buttonPadding;
	this.buttonPaddingMeasure = buttonPaddingMeasure;
}

function Button (top, left, width, height)
{
	this.top = parseInt(top);
	this.left = parseInt(left);
	this.width = parseInt(width);
	this.height = parseInt(height);

	this.display = function(container)
	{
		var but = document.createElement('div');
		but.width = this.width;
		but.height = this.height;
		but.style.top = this.top;
		but.style.left = this.left;
		but.style.height = this.height;
		but.style.width = this.width;
		but.style.position = "relative";
		but.style.backgroundColor = "blue";
		but.style.display = "block";
		but.innerHTML = "button";
		container.appendChild(but);
	}
}

function ButtonContainer(settings, buttonArray, width, height)
{
	this.width = parseInt(width);
	this.height = parseInt(height);
	this.settings = settings;
	this.buttons = buttonArray;
	
	this.whichSquare = function(len)
	{
		var squares = [2, 3, 4, 5, 6, 7];
		for (var i = 0; i < squares.length; i++)
			if (len <= squares[i] * squares[i]) return squares[i];

		return [];
	}

	this.resizedButtonWidth = function(buttonsCountInOneRow)
	{
		return Math.floor(this.width / buttonsCountInOneRow);
	}
	
	this.resizedButtonHeight = function(buttonsCountInOneRow)
	{
		return Math.floor(this.height / buttonsCountInOneRow);
	}

	this.resizeButton = function(buttonsCountInOneRow, pad)
	{
		var oneMore = 0
		if (pad > 0)
		{
			oneMore = Math.floor(((buttonsCountInOneRow + 1) * pad) / buttonsCountInOneRow);
			pad = oneMore;
		}
		var newBut = new Button(0,0, this.resizedButtonWidth(buttonsCountInOneRow) - pad, this.resizedButtonHeight(buttonsCountInOneRow) - pad);
		return newBut;
	}
	
	this.padding = function(measure, pad, buttonsInRow)
	{
		var value = "";
		var resizedWidth = this.resizedButtonWidth(buttonsInRow);
		switch (measure)
		{
			case "%":
				value = resizedWidth * parseFloat(pad);
			break;
			case "px":
				value = parseInt(pad);
			break;
			default:
				value = resizedWidth * 0.1;
			break;
		}
		return value;
	}
	
	this.display = function()
	{
		//var container = document.getElementById('body');
		//container.innerHTML = "";
		
		var newButtons = [];
		
		var buttonsInRow = this.whichSquare(this.buttons.length);
		// Ti.API.info("buttonsInRow: " + buttonsInRow);
		var pad = this.padding(this.settings.buttonPaddingMeasure, this.settings.buttonPadding, buttonsInRow);
		// Ti.API.info("pad: " + pad);
		var heightRemainder = Math.ceil(((buttonsInRow - Math.ceil(this.buttons.length / buttonsInRow)) * this.resizedButtonHeight(buttonsInRow)) / buttonsInRow);
		var rows = 0;
		var remainder = 0;
		var actHorPos = pad;
		var actVerPos = heightRemainder + pad;
		// Ti.API.info("heightremainder: " + heightRemainder + " - actHorPos: " + actHorPos + " - actVerPos: " + actVerPos);
		for (var i = 0; i < this.buttons.length; i++)
		{
			var newBut = this.resizeButton(buttonsInRow, pad);
	
			newBut.left += actHorPos;
			newBut.top += actVerPos;
			
			//newBut.display(container);	//taken out by DH because we are not displaying things in a DIV anymore
			// Ti.API.info("displaying button: "+newBut.left + ", " + newBut.top +", " + newBut.width +", " + newBut.height);
			newButtons.push(newBut);

			actHorPos += newBut.width + pad;
			//actVerPos -= newBut.height;	//taken out by DH because titanium positions things differently than the original HTML function did

			if (((i + 1) % buttonsInRow) == 0)
			{
				++rows;
				if (Math.floor(this.buttons.length / buttonsInRow) == rows) {
					var curI = this.buttons.length - i - 1;
					remainder = Math.floor((((buttonsInRow * newBut.width) + pad * (buttonsInRow + 1)) - (curI * newBut.width + pad * (curI- 1))) / 2);
				}
				actHorPos = (remainder > 0) ? remainder : pad;
				actVerPos += newBut.height + heightRemainder + pad;
			}
		}
		// Ti.API.info("newButtonsLength: "+newButtons.length);
		return newButtons;
	}
}

function create(numButtons, padding, containerWidth, containerHeight)
{
	// if (obj.buttonscount.value == "")
	// {
		// alert("Enter the number of buttons you want to be displyed");
		// return false;
	// }

	var buttons = new Array();
	for (var i = 0; i < numButtons; i++)
	{
		var but = new Button(0,0,90,90);
		buttons.push(but);
	}

	var sets = new Settings();
	sets.buttonPadding = parseFloat(padding);
	// var t = "";
	// if (obj.measure[1].checked) t = "%";
	// else if (obj.measure[0].checked) t = "px";
	sets.buttonPaddingMeasure = "%";
	//var bc = new ButtonContainer(sets, buttons, document.getElementById('body').style.width, document.getElementById('body').style.height);
	var bc = new ButtonContainer(sets, buttons, containerWidth, containerHeight);
	return bc.display();
}