Ti.API.warn("update.javascript LOADED");
/*
 * version 1.0 - created for launch
 *
 * these functions download the most recent updates in all active categories and update the buttons with a flag
 */
(function() {
	var update = {};
	if (Titanium.App.Properties.getList("newData") == null) {//first time run
		var NewDataPageList = [{
			facebook : false,
			twitter : false,
			blog : false,
			photos : false,
			calendar : false
		}];
		Titanium.App.Properties.setList("newData", NewDataPageList);
	}

	var new_col = '#f22';
	//colour used for 'new data' highlight on button text

	update.getModulesByType = function(type) {
		var mods = {};
		for (mod in pages) {
			if (pages[mod].name == type) {
				mods[mod] = pages[mod];
			}
		}
		return mods;
	};

	update.updateButtonsWithNewData = function(p) {
		Ti.API.info("updating menu buttons: " + p);

		for (c in menuView.children) {//cycle through buttons
			if (menuView.children[c].children[0].mytitle == p) {//look for a particular button
				//			Ti.API.info("newData on " + p + " page is: " + Titanium.App.Properties.getList("newData")[0][p]);
				if (Titanium.App.Properties.getList("newData")[0][p]) {//if the "new_data" is different from the old_data, turn the colour red
					//				Ti.API.debug("evaluated true");
					menuView.children[c].children[1].color = new_col;
					//change it's color
					//				Ti.API.debug("changed colour to red");
				} else {
					//				Ti.API.debug("evaluated false");
					menuView.children[c].children[1].color = col_title;
					//change it's color back
					//				Ti.API.debug("reset colour");
				}
			}
		}

	};

	update.updateAllButtons = function() {
		for (mypage in pages) {
			updateButtonsWithNewData(mypage);
		}
	};

	update.compareNewData = function(newStuff, page) {
		var oldStuff = Titanium.App.Properties.getString(page, '');
		Ti.API.info("oldstuff=" + oldStuff + "  newstuff=" + newStuff);
		if (oldStuff != newStuff) {
			var list = Titanium.App.Properties.getList("newData");
			list[0][page] = true;
			Ti.API.debug("therefor - new data found: " + list[0][page]);
			Titanium.App.Properties.setList("newData", list);
		}
		Titanium.App.Properties.setString(page, newStuff);
		updateButtonsWithNewData(page);
	};

	update.checkTwitter = function() {
		Ti.API.info("checking for new twitter data");
		var query = "select entry from xml where url in(";
		for (var i = 0; i < twitter_feeds.length; i++) {
			query += "'http://twitter.com/statuses/user_timeline/" + twitter_feeds[i] + ".atom?page=0&count=10'";
			if (i < twitter_feeds.length - 1) {
				query += ", ";
			}
		}
		query += ") | sort(field='entry.published', descending='true') | truncate(count=1)";

		Ti.API.info('attempting twitter yql query: ' + query);
		Titanium.Yahoo.yql(query, function(e) {
			if (e.data == null) {
				Ti.API.info("sorry - no YQL data returned");
				return;
			} else {
				Ti.API.info('YQL success!');
				var newData = e.data.feed.entry.updated;
				Ti.API.info('newest twitter data: ' + newData);
				compareNewData(newData, 'twitter');
			}
		});
	};

	update.checkBlog = function() {
		Ti.API.info("checking for new blog data");
		var query = 'select * from rss where url="http://pipes.yahoo.com/pipes/pipe.run?_id=9f1f8b90337030754853490f541a4f55&_render=rss&urls=';
		for ( f = 0; f < vars.blog_feeds.length; f++) {
			query += urlEncode(vars.blog_feeds[f]);
			// append each feed to the query string
			if (f < vars.blog_feeds.length - 1) {
				query += urlEncode(',');
				// separate with comma if it's not the last one
			}
		}
		query += '%26ie%3Dutf-8%26num%3D10%26output%3Drss" | truncate(count=1)';

		Ti.API.info("calling blog yql statement: " + query);
		Titanium.Yahoo.yql(query, function(e) {
			if (e.data == null) {
				Ti.API.info("sorry - no YQL data returned");
				return;
			} else {
				Ti.API.info('YQL success!');
				var newData = e.data.item.pubDate;
				Ti.API.info('newest blog data: ' + newData);
				compareNewData(newData, 'blog');
			}
		});
	};

	function checkHoursModule(mod) {
		Ti.API.info("checking hours for mod " + mod);
		// var button = myApp.global.findButtonByIndex(menuView, mod);	//finds the button image
		var button = myApp.global.findButtonContainerByIndex(menuView, mod);	//finds the button image CONTAINER view
		Ti.API.info("hours button: ");
		Ti.API.info(button);

		if (button && button != null) {
			hours = pages[mod].data.hours_data;
			var isOpen = myApp.global.checkHours(hours);
			var isOpenLabel = "OPEN"; // default
			if (isOpen) {
				Ti.API.info("open!");
				// if (pages[mod].icon == "hours0.png" || pages[mod].icon == "undefined") {
					// button.image =  "/mymodules/hours/hours_open.png";
				// } else {
					// button.image = 'https://origin-files.infinitemonkeys.mobi/userfiles/' + pages[mod].icon;
				// }
			} else {

				// Ti.API.info("closed :-(");
				// if (pages[mod].data.hours_closed_icon == null || pages[mod].data.hours_closed_icon == 'undefined') {
					// button.image = "/mymodules/hours/hours_closed.png";
				// } else {
					// var iconFile = ExtDir + 'custom/' + pages[mod].data.hours_closed_icon;
					// button.image = iconFile;
					// var file = Titanium.Filesystem.getFile(iconFile);
					// if (!file.exists()) {
						// iconFile = resDir + 'custom/' + pages[mod].data.hours_closed_icon;
						// button.image = iconFile;
					// }
					// var file = Titanium.Filesystem.getFile(iconFile);
					// if (!file.exists())
						// button.image = 'https://origin-files.infinitemonkeys.mobi/userfiles/' + pages[mod].data.hours_closed_icon;
// 
				// }
				isOpenLabel = "CLOSED";
			}
			
			var openCloseLabel = Ti.UI.createLabel({
				text : isOpenLabel,
				color : vars.col_text,
				textAlign : 'center',
				top:"20%",
				width : iconContainerWidth * 2,
				font : {
						fontSize : iconText*1.5
				},
				shadowColor: col_back,
			  	shadowOffset: {x:1, y:1},
			  	shadowRadius: 3
			});
			
			Ti.API.info("ADDING OPENCLOSELABEL: " + openCloseLabel);
			button.add(openCloseLabel);
		}
	};

	update.checkForNewData = function() {
		var type = '';
		for (mod in pages) {
			type = pages[mod].name;
			switch (type) {
			case "hours":
				//check opening hours
				Ti.API.info("found hours module: " + mod);
				checkHoursModule(mod);
				break;
			}
		}
	};

	function showMessage(isNew) {
		if(menuStyle=='grid'){
			if(isNew==true){
				var alertDialog = Titanium.UI.createAlertDialog({
					title : L("New_Message"),
					message : L("You_got_a_new_message"),
					buttonNames : [L('Cancel'), L("Show_Me")],
					cancel : 0
				});
				alertDialog.addEventListener('click', function(e) {
					if (e.index == 1) {//view message button pressed
						var message_html = myApp.global.makehtml(Titanium.App.Properties.getString('message', ''), "#000");
						 myApp.global.openHTMLWebWindow(message_html);
					}
				});
				alertDialog.show();
			}
		}else{
			var message_html = myApp.global.makehtml(Titanium.App.Properties.getString('message', ''));
			Ti.API.info("setting inbox_message to: " + message_html);
			messageInbox.html = message_html;
		}
	};

	update.checkMessages = function() {
		Ti.API.info("checking for new messages: " + vars.message_url);
		var message_url = vars.message_url;
		xhr = Titanium.Network.createHTTPClient();
		xhr.setTimeout(30000);
		xhr.open('GET', message_url);
		xhr.onerror = function(e) {
			// alert("ERROR " + e.error);
			Titanium.API.info("Error checking messages in update.javascript: " + e.error);
		};
		xhr.onload = function() {
			var newMessage = (this.responseText != null) ? this.responseText : '';

			var newData = Titanium.Utils.md5HexDigest(newMessage);
			//create a md5 hash of data to save to property
			Ti.API.info('newest message: ' + newMessage);

			if (Titanium.App.Properties.getString('message', '') != newMessage) {
				if (newMessage != '' && newMessage != 'undefined' && newMessage != 'null') {
					Ti.API.info("new message is different than old message, so showing new");
					Titanium.App.Properties.setString('message', newMessage);
					showMessage(true);
				}
			}else{
				Ti.API.info("same old message...");
				showMessage(false);
			}

		};
		xhr.send();
	};

	var loader = Titanium.UI.createActivityIndicator({
		height : 50,
		width : 'auto',
		message : L("Fetching_Latest_Data"),
		// style : Titanium.UI.iOS.ActivityIndicatorStyle.DARK,
		zIndex : 20
	});

	
	myApp.update = update;
})();
