var socket = io.connect('https://utils.infinitemonkeys.mobi:3010');

socket.on('connect', function() {
	//Fires event listern in private_chat.js to open the chat window
	Ti.App.fireEvent('private_chat_connected');	
	Ti.API.info("Private Chat...");

});

// To know the status
socket.on('reconnect', function() {
	message('System', 'Reconnected to the server');
});
socket.on('reconnecting', function() {
	message('System', 'Attempting to re-connect to the server');
});
socket.on('error', function(e) {
	message('System', e ? e : 'A unknown error occurred');
});

// get the broadcat message
socket.on('broadcast_to_user', function(e) {
	// message('System', 'broadcast_to_user:on   ');
	Ti.API.info('fired -> broadcast_to_user GOT ' + JSON.stringify(e));
	Ti.App.fireEvent('set_broadcast_message', {
		data : e
	});
});

// get the broadcast message in Private Chat
socket.on('broadcast_to_user', function(e) {
	// message('System', 'broadcast_to_user:on   ');
	Ti.API.info('fired -> broadcast_to_user Private GOT ' + JSON.stringify(e));
	Ti.App.fireEvent('set_message_privateChat', {
		data : e
	});
});

// set history data for the private chat
socket.on('set_history_data', function(e) {
	// message('System', 'broadcast_to_user:on   ');
	Ti.API.info('fired -> set_history_data GOT ' + JSON.stringify(e));
	Ti.App.fireEvent('got_history_data', {
		data : e
	});
});

socket.on('user_current_status', function(e) {
	Ti.API.info('fired -> user_current_status GOT ' + JSON.stringify(e));
	Ti.App.fireEvent('get_user_status', {
		data : e
	});
});

// get private chat request
socket.on('request_for_chat', function(e) {
	Ti.API.info('fired -> request_for_chat GOT ' + JSON.stringify(e));
	Ti.App.fireEvent('got_chat_request', {
		data : e
	});
});

// get private chat user offline
socket.on('after_user_offline', function(e) {
	Ti.API.info('fired -> after_user_offline GOT ' + JSON.stringify(e));
	Ti.App.fireEvent('private_chat_offline', {
		data : e
	});
});

// deny private chat request
socket.on('notify_deny_request', function(e) {
	Ti.API.info('fired -> notify_deny_request GOT ' + JSON.stringify(e));
	Ti.App.fireEvent('deny_chat_req', {
		data : e
	});
});

socket.on('start_chat', function(e) {
	Ti.API.info('fired -> start_chat GOT ' + JSON.stringify(e));
	Ti.App.fireEvent('got_start_chat', {
		data : e
	});
});

/*
 * Event Listeners
 */

$(function() {
	
	Ti.App.addEventListener('disconnect_socket',function(e){
		socket.disconnect(true);
	});

	Ti.App.addEventListener('create_private_node_room', function(e) {
		Ti.API.info('fired -> create_private_node_room inPC' + JSON.stringify(e));

		socket.emit("create_private_node_room", {
			app_id : e.app_id,
			me_deviceId : e.me_deviceId,
			room_id : e.room_id,
			other_deviceId : e.other_deviceId,
			timeZone : e.timeZone,
		});

	});

	// Ti.App.addEventListener('broadcast_to_user', function(e) {
		// Ti.API.info('fired -> broadcast_to_user details:- ' + JSON.stringify(e));
// 
		// // Ti.API.info('tokenEncoded  ' + tokenEncoded);
		// socket.emit("broadcast_to_user", JSON.stringify({
			// appId : e.app_id,
			// deviceId : e.from_id,
			// userName : e.user_name,
			// msg : e.message,
			// isGroupChat : e.is_group_chat,
			// to_Id : e.to_id
		// }));
	// });

	// Send message in private chat.....
	Ti.App.addEventListener('broadcast_private_Chat', function(e) {
		Ti.API.info('fired -> broadcast_private_Chat details:- ' + JSON.stringify(e));

		// Ti.API.info('tokenEncoded  ' + tokenEncoded);
		socket.emit("broadcast_to_user", JSON.stringify({
			appId : e.appId,
			deviceId : e.deviceId,
			userName : e.userName,
			msg : e.msg,
			isGroupChat : e.isGroupChat,
			to_id : e.to_id
		}));
	});

	Ti.App.addEventListener('deny_chat_request', function(e) {
		Ti.API.info('fired -> deny_chat_request details:- ' + JSON.stringify(e));
		socket.emit("deny_chat_request", {
			from : e.from,
			toName : e.toName,
		});
	});

	Ti.App.addEventListener('subscribe', function(e) {
		Ti.API.info('fired -> subscribe details:- ' + JSON.stringify(e));
		socket.emit("subscribe", {
			from : e.fromID,
			to : e.toID,
			private_room_id : e.private_room_id,
			check : e.checkVal
		});
	});

	// check_active_user : Checks weather the user is active or not
	Ti.App.addEventListener('check_active_user', function(e) {
		Ti.API.info('fired -> check_active_user details:- ' + JSON.stringify(e));

		// Ti.API.info('tokenEncoded  ' + tokenEncoded);
		socket.emit("check_active_user", {
			appId : e.app_id,
			check_user : e.chk_user,
			me : e.meVal,
			check_username : e.chk_userName,
			Email : e.email,
			check : e.checkVal
		});
	});

});
