var socket = io.connect('https://utils.infinitemonkeys.mobi:3010');

socket.on('connect', function() {
	//Fires event listern in chat.js to open the chat window
	Ti.App.fireEvent('user_connected');

});

// To know the status
socket.on('reconnect', function() {
	message('System', 'Reconnected to the server');
});
socket.on('reconnecting', function() {
	message('System', 'Attempting to re-connect to the server');
});
socket.on('error', function(e) {
	message('System', e ? e : 'A unknown error occurred');
});

// get all the online users hits after every 3 minutes....
socket.on('get_online_users',function(e){
	Ti.API.info('fired -> get_online_users GOT ' + JSON.stringify(e));
	Ti.App.fireEvent('get_online_users', {
		data : e
	});
});

// get the broadcat message
socket.on('broadcast_to_user', function(e) {
	// message('System', 'broadcast_to_user:on   ');
	Ti.API.info('fired -> broadcast_to_user GOT ' + JSON.stringify(e));
	Ti.App.fireEvent('set_broadcast_message', {
		data : e
	});
});

// get the user current Status
socket.on('user_current_status', function(e) {
	Ti.API.info('fired -> user_current_status GOT ' + JSON.stringify(e));
	Ti.App.fireEvent('get_user_status', {
		data : e
	});
});

// get private chat request
socket.on('request_for_chat', function(e) {
	Ti.API.info('fired -> request_for_chat GOT ' + JSON.stringify(e));
	Ti.App.fireEvent('got_chat_request', {
		data : e
	});
});

socket.on('notify_deny_request', function(e) {
	Ti.API.info('fired -> notify_deny_request GOT ' + JSON.stringify(e));
	Ti.App.fireEvent('deny_chat_req', {
		data : e
	});
});

socket.on('start_chat', function(e){
	Ti.API.info('fired -> start_chat GOT ' + JSON.stringify(e));
	Ti.App.fireEvent('got_start_chat', {
		data : e
	});
});

// deny private chat request
// socket.on('deny_chat_request',function(e){
// Ti.API.info('fired -> deny_for_chat GOT ' + JSON.stringify(e));

// });

/*
 * Event Listeners
 */
$(function() {
	
	Ti.App.addEventListener('disconnect_socket',function(e){
		socket.disconnect(true);
	});

	Ti.App.addEventListener('create_node_room', function(e) {
		Ti.API.info('fired -> create_node_room appId' + e.app_id);
		socket.emit("create_node_room", {
			appId : e.app_id,
			deviceId : e.device_id
		});
	});
	
	Ti.App.addEventListener('get_connected_clients', function(e) {
		Ti.API.info('fired -> get_connected_clients roomId ' + e.roomid);
		socket.emit("get_connected_clients", {
			roomid : e.roomid
		});
	});

	Ti.App.addEventListener('broadcast_to_user', function(e) {
		Ti.API.info('fired -> broadcast_to_user details:- ' + JSON.stringify(e));

		// Ti.API.info('tokenEncoded  ' + tokenEncoded);
		socket.emit("broadcast_to_user", JSON.stringify({
			appId : e.app_id,
			deviceId : e.from_id,
			userName : e.user_name,
			msg : e.message,
			isGroupChat : e.is_group_chat
		}));
	});	

	Ti.App.addEventListener('deny_chat_request', function(e) {
		Ti.API.info('fired -> deny_chat_request details:- ' + JSON.stringify(e));
		socket.emit("deny_chat_request", {
			from : e.from,
			toName : e.toName,
		});
	});

	Ti.App.addEventListener('subscribe', function(e) {
		Ti.API.info('fired -> subscribe details:- ' + JSON.stringify(e));
		socket.emit("subscribe", {
			from : e.fromID,
			to : e.toID,
			private_room_id : e.private_room_id,
			check : e.checkVal
		});
	});

	// check_active_user : Checks weather the user is active or not
	Ti.App.addEventListener('check_active_user', function(e) {
		Ti.API.info('fired -> check_active_user details:- ' + JSON.stringify(e));

		// Ti.API.info('tokenEncoded  ' + tokenEncoded);
		socket.emit("check_active_user", {
			appId : e.app_id,
			check_user : e.chk_user,
			me : e.meVal,
			check_username : e.chk_userName,
			Email : e.email,
			check : e.checkVal
		});
	});

});
